<!doctype html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>GraphQL and TangoGQL</title>
	<link rel="stylesheet" href="css/reveal.css">
    <link rel="stylesheet" href="css/theme/maxiv_white.css">
    <link rel="stylesheet" href="css/theme/custom.css">

</head>

<body>
	<!-- Wrap the entire slide show in a div using the "reveal" class. -->
	<div class="reveal">
		<!-- Wrap all slides in a single "slides" class -->
		<div class="slides">

		<!-- ALL SLIDES GO HERE -->
		<!-- Each section element contains an individual slide -->
		<section data-background="images/maxiv_rings.png">
			<h1>GraphQL and TangoGQL</h1>
			<p>Vincent Hardion on behalf of KITS/SKA - 2020</p>
            <aside class="notes" data-markdown>
            Just present yourself.
            </aside>
		</section>

        <section data-markdown data-separator="^\n---\n$" data-separator-vertical="^\n--\n$">
            <script type="text/template">
                # Agenda

                - What?
                - Why?
                - How?
                - TangoGQL

                ---

                # What?

                --

                # What is GraphQL?

                > GraphQL is a new API standard that provides a more efficient, powerful and flexible alternative to REST.

                - GraphQL is a query language for APIs, and a server-side runtime for executing queries by using a type system you define for your data.
                - Not language specific
                - A Single endpoint
                - Get what you want: Declarative data fetching. A client can specify exactly what data it needs from an API
                - Back end Front end decoupled via Schema
                - Database agnostic.

                --

                # Main difference with REST?

                > GQL is what you get when your Frontend Developers gets tired of asking your backend developers for new endpoints.

                - REST is fixed schema, GQL is flexible schema.
                - REST is based on multiple end-points, GQL on single endpoint

                ---

                # Why?
                

                --

                ## Why GraphQL instead of REST?

                "It's Graphs All the Way Down" corresponding to the Tango Object Model

                <img src="images/tango-graph.png" width="80%" height="auto">

                --

                ## Other advantages

                2. Get many resources in a single request
                3. Improve maintainability 
                4. Fast development
                5. Asynchronous

                > Schema and strong type definition based. Act as a contract between back and front end.
                > Making GraphQL more like a query language

                --

                ## Example

                With REST API, you gather the data by accessing multiple endpoints.

                Let's say you want to display the value of a device attribute.

                ```
                BASE_URL = http://rest.maxiv.lu.se:8000/tango/rest/rc3/hosts/csdb.maxiv.lu.se/10000/

                --> HTTP GET:  BASE_URL/devices
                <-- list of devices
                ```


                For each device (if you already know the attribute name):
                
                ```
                --> HTTP GET: BASE_URL/devices/<device>/attributes/ampli/value
                <-- {
                      "value":27.0,
                      "timestamp":1536317952,
                      "name":"ampli",
                      "quality":"ATTR_VALID"
                    }

                ```

                In case you want all of the attributes values:

                ```
                --> HTTP GET: BASE_URL/devices/<device_name>/attributes
                <-- list of attributes
                ```

                --

                With GraphQL

                1 HTTP POST, query:

                ```
                {
                    devices(pattern: "sys/tg_test/*") {
                      attributes(pattern: "ampli") {
                        name
                        value
                        timestamp
                        quality
                      }
                      }
                  }
                ```

                Answer:

                ```
                {
                    "data": {
                      "devices": [
                        {
                          "attributes": [
                            {
                              "name": "ampli",
                              "value": 27,
                              "timestamp": 1536318691,
                              "quality": "ATTR_VALID"
                            }
                          ]
                        }
                      ]
                    }
                  }
                ```

                --

                In case you want all attributes 

                ```
                {
                    devices(pattern: "sys/tg_test/*") {
                      attributes(pattern: "*") {
                        name
                        value
                        timestamp
                        quality
                      }
                   }
                }
                ```
                
                Answer:
                ```
                {
                  "errors": [
                    {
                      "reason": "AttrValueNotSet",
                      "field": "value",
                      "device": "sys/tg_test/1",
                      "attribute": "no_value"
                    },
                    {
                      "reason": "exception test",
                      "desc": "here is the exception you requested",
                      "device": "sys/tg_test/1",
                      "attribute": "throw_exception"
                    }
                  ],
                  "data": {
                    "device": {
                      "attributes": [
                        {
                          "name": "state",
                          "value": "RUNNING"
                        },
                        {
                          "name": "status",
                          "value": "The device is in RUNNING state."
                        },
                        {
                          "name": "ampli",
                          "value": 121
                        },
                        {
                          "name": "boolean_image",
                          "value": [
                            [
                              false,
                              false,
                ...
                ```

                ---

                # How?

                --

                ## How Does It Work? (Basic concepts) 

                Schema is the definition of:

                - Types and Fields
                - Query: fetch data via resolvers.
                - Mutation: create, update and delete.
                - Subscription: real-time connection with the server, events from tango through websockets.

                for your data using the GraphQL Schema Definition Language

                --

                ## Type and Fields

                ```
                type Device {
                    name: String
                    state: String
                    properties(pattern: String): [DeviceProperty]
                    attributes(pattern: String): [DeviceAttribute]
                    commands(pattern: String): [DeviceCommand]
                    server: DeviceInfo
                    pid: Int
                    startedDate: String
                    stoppedDate: String
                    exported: Boolean
                }
                ```

                --

                ```
                type DeviceAttribute {
                    name: String
                    device: String
                    datatype: String
                    dataformat: String
                    writable: String
                    label: String
                    unit: String
                    description: String
                    value: ScalarTypes
                    writevalue: ScalarTypes
                    quality: String
                    timestamp: Float
                    displevel: String
                    minvalue: ScalarTypes
                    maxvalue: ScalarTypes
                    minalarm: ScalarTypes
                    maxalarm: ScalarTypes
                    enumLabels: ScalarTypes
                }
                ```

                --

                ## Query

                - Fetch data via Resolvers
                - Returns only the data you ask for.
                - Allows nested information

                ```
                type Query {
                    device(name: String!): Device!
                }
                ```

                --

                ## Mutations

                3 types of mutations:

                - Creating new data
                - Updating existing data
                - Deleting existing data

                ```
                type Mutation{
                    putDeviceProperty(device: String!, name: String!, value: [String]): PutDeviceProperty
                    deleteDeviceProperty(device: String!, name: String!): DeleteDeviceProperty
                    setAttributeValue(device: String!, name: String!, value: ScalarTypes!): SetAttributeValue
                    executeCommand(device: String!, command: String!, argin: ScalarTypes): ExecuteDeviceCommand
                }
                ```

                --

                ## Subscriptions

                Real-time connection with the server in order to get informed about events

                ```
                type Subscription {
                    changeEvent(models: [String]): ChangeEvent
                }
                ```

                ---

                # TangoGQL

                GraphQL interface for Tango. 

                Stack:
                - aiohttp:
                    - Async HTTP server with support for websockets
                - graphene:
                    - python library for building GraphQL APIs
                - Taurus:
                    - Internal implementation using TaurusAttributes 
                - PyTango
                - python >= 3.6

                --

                # Architecture

                <img src="images/architecture.png" width="80%" height="auto">

                --

                # Repository

                > https://gitlab.com/MaxIV/web-maxiv-tangogql

                <img src="images/repository.png" width="80%" height="auto">

                ---

                # UI for GraphQL
                
                - WebJive: of course!
                    - https://webjive-demo.maxiv.lu.se/demodb/

                - GraphiQL: usually deploy with webjive 
                    - https://webjive-demo.maxiv.lu.se/demodb/graphiql/

                - curl ;-)
                    - curl -d '{"query":"\n  query {\n    info\n  }","variables":{}}' https://webjive-demo.maxiv.lu.se/demodb/db


                --

                # GraphiQL

                <img src="images/graphiql_1.png" width="80%" height="auto">

                --

                # GraphiQL

                <img src="images/graphiql_2.png" width="80%" height="auto">

                --

                # Example of client in python
                 
                ```py
                from python_graphql_client import GraphqlClient
                
                client = GraphqlClient('https://webjive-demo.maxiv.lu.se/demodb/db')
                
                result = client.execute('''
                query {
                  devices(pattern:"sys/tg_test/*") {
                    attributes(pattern: "ampl*") {
                      name
                      value
                    }
                  }
                }
                ''')
                
                print(result)
                ``` 

                Answer:
                ```
                {'data': {'devices': [{'attributes': [{'name': 'ampli', 'value': 121.0}]}]}}
                ```

                ---

                # How to install

                1. Clone the repository.

                  ```
                  git clone https://gitlab.com/MaxIV/web-maxiv-tangogql.git
                  ```

                2. Install the dependencies
                  - with pip: 
                  ```
                  $ pip install -r requirements.txt
                  ```
                  - Conda environment can be created using the _environment.yml_.

                3. Run
                  ```
                  $ python -m tangogql
                  ```
                  - Dockerfile is provided and can be used to run the server

                ---

                # Some examples

                --

                > Query

                ``` 
                query {
                  devices(pattern:"sys/tg_test/*") {
                    attributes(pattern: "ampl*") {
                      name
                      value
                    }
                  }
                }
                ``` 

                --

                > Several queries with alias
                ``` 
                  query {
                    ampli: devices(pattern:"sys/tg_test/*") {
                      attributes(pattern: "ampl*") {
                        value
                        name
                      }
                    }
                    scalar: devices(pattern:"sys/tg_test/1") {
                      attributes(pattern: "double_scalar") {
                        value
                        name
                      }
                    }
                  }
                ``` 

                --

                > Queries without repetition

                ``` 
                fragment comparisonFields on DeviceAttribute {
                  value
                  name
                }
                  
                query {
                  ampli: devices(pattern:"sys/tg_test/*") {
                    attributes(pattern: "ampl*") {
                      ...comparisonFields
                    }
                  }
                  scalar: devices(pattern:"sys/tg_test/1") {
                    attributes(pattern: "double_scalar") {
                      ...comparisonFields
                    }
                  }
                }
                ``` 

                --

                > Query with variable

                ``` 
                query some_devices($device: String) {
                  ampli: devices(pattern: $device) {
                    attributes(pattern: "ampl*") {
                		  value
                  		name
                    }
                  }
                  scalar: devices(pattern: $device) {
                    attributes(pattern: "double_scalar") {
                      value
                		  name
                    }
                  }
                }
                ``` 

                Query variable:
                ``` 
                {
                  "device": "sys/tg_test/*"
                }
                ``` 

                --

                > Query with Directive

                ``` 
                query some_devices($device: String, $with_name: Boolean!) {
                  ampli: devices(pattern: $device) {
                    attributes(pattern: "ampl*") {
                		  value
                  		name @include(if: $with_name)
                    }
                  }
                }

                Query variable:
                {
                  "device": "sys/tg_test/*",
                  "with_name": false
                }
                ``` 

                --

                > Mutation

                - For mutation you need to be login first
                    - user1/abc123

                ``` 
                mutation {
                  setAttributeValue(
                    device: "sys/tg_test/1"
                    name: "ampli"
                    value: 10
                  ) 
                }
                ``` 

                --

                > Mutation with feedback

                ``` 
                mutation {
                  setAttributeValue(
                    device: "sys/tg_test/1"
                    name: "ampli"
                    value: 12
                  ) {
                    ok
                  }
                }
                ``` 

                --

                > Mutation with read back

                ``` 
                mutation {
                  setAttributeValue(
                    device: "sys/tg_test/1"
                    name: "ampli"
                    value: 12
                  ) {
                    ok
                    attribute {
                      name
                      value
                      unit
                      quality
                      timestamp
                    }
                  }
                }
                ``` 

                - In case of multiple mutation: While query fields are executed in parallel, mutation fields run in series, one after the other.

                --

                > Subscription

                ``` 
                subscription {
                  attributes(fullNames: ["sys/tg_test/1/ampli"]) {
                    attribute
                    device
                    fullName
                    value
                    writeValue
                    quality
                    timestamp
                  }
                }
                ``` 

 
            </script>
        </section>
        
        
        <!-- <section data-background="images/dev_hell.gif"
        data-background-transition="zoom">
        <h3><font color="white">Enjoy the Session!!</font></h3>
        </section> -->
        
        <!-- <section>
            <h2>Single Board Computer</h2>
            <div id="right">
                <img src="images/SBC.jpg" width="50%" height="auto">
            </div>
            <div id="left">
                <section data-markdown>
                    - Light Linux OS distribution: Yocto
                    - Divided in layers:
                      - Drivers to control HW, interfaces and FPGA
                      - Middleware: Modular SW layer to handle communication protocols, algorithms, etc
                      - Applications: Apps to control the equipment, i.e. web app
                </section>
            </div>
            <aside class="notes" data-markdown>
                - This is the basic block diagram, internals of EM.
                - Left: HW, Right: Control
            </aside>
        </section> -->

        <!-- <section>
            <section data-markdown data-separator="^\n---\n$" data-separator-vertical="^\n--\n$">
                <script type="text/template">
                    ## Some title
                </script>
            </section>
                <div id="left">
                    <section data-markdown data-separator="^\n---\n$" data-separator-vertical="^\n--\n$">
                            <script type="text/template">
                                - Something to the left
                                - Some more info
                                - And something else
                            </script>
                        </section>                        
                </div>
                <div id="right">
                    <section data-markdown data-separator="^\n---\n$" data-separator-vertical="^\n--\n$">
                            <script type="text/template">
                                - Something to the right
                                ![alt text](images/maxiv_rings.png)
                            </script>
                        </section>                
                </div>
        </section> -->
        <!-- <section>
            <div style="text-align: left; float: left;">
                <p data-markdown>- This is my first left element</p>
                <p data-markdown>- This is my second left element</p>
            </div>
            
            <div style="text-align: right; float: right;">
                <p data-markdown>- This is my first right element</p>
                <p data-markdown>- This is my second rightelement</p>
            </div>
        </section> -->

        </div>
	</div>
	<script src="lib/js/head.min.js"></script>
	<script src="js/reveal.js"></script>

	<script>
		// Required, even if empty.
		Reveal.initialize({
      // More info https://github.com/hakimel/reveal.js#dependencies
      // Display a presentation progress bar
      progress: true,

      // Display the page number of the current slide
      slideNumber: true,

      // Enable keyboard shortcuts for navigation
      keyboard: true,

      // Turns fragments on and off globally
      fragments: true,

      // Hides the address bar on mobile devices
      hideAddressBar: true,

      dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
        { src: 'plugin/zoom-js/zoom.js', async: true },
      ]
		});
	</script>
</body>
</html>
